class String
	def replace_words(words)
		self.dup.replace_words!(words)
	end
	def replace_words!(words)
		return self unless words
		keys = words.keys.sort{|a,b|
			r = a.size <=> b.size
			-(r == 0 ? a <=> b : r)
		}.map{|k|
			Regexp::escape(k)
		}
		re = /(#{keys.join('|')})/m
		self.gsub!(re){
			words[$1].to_s
		}
		return self
	end
	def blank?
		/\A\s*\z/ === self ? true : false
	end
	def emb(*prms)
		time = prms.last if prms.last.class == Time
		arr = Array::new
		aft = nil
		self.scan(/([^%]*)(\%\d+|\%.)/){
			prev, rep, aft = $1, $2, $'
			arr << prev
			case rep
			when /\%(\d+)/ then
				arr << prms[$1.to_i-1]
			when /\%[A-Za-z\%]/ then
				if time then
					arr << time.strftime(rep)
				else
					arr << rep
				end
			else
				arr << rep
			end
		}
		if aft then
			arr << aft
		elsif arr.empty? then
			arr << self
		end
		return arr.join
	end
	def meval
		self.gsub(/\\./){eval(%Q["#{$&}"].untaint)}
	end
	def to_t
		n = self.scan(/\d+/)
		return nil if n.empty?
		return Time::local(*n)
	end
	def to_any
		case self
		when /^\/(.+)\/$/ then
			Regexp::new($1)
		when '' then
			nil
		else
			self
		end
	end
	def match?(pattern, ignorecase=false)
		case pattern
		when Array then
			pattern.each do |pat|
				return true if match?(pat, ignorecase)
			end
		when Regexp then
			return true if pattern === self
		when String then
			opt = ignorecase ? Regexp::IGNORECASE : 0
			re = Regexp::new(Regexp::escape(pattern), opt)
			return true if re === self
		end
		return false
	end
end
